#!/usr/bin/env node
"use strict";function e(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0}),require("core-js/modules/es.array.flat"),require("core-js/modules/es.array.unscopables.flat"),require("core-js/modules/es.promise");var n=e(require("fs")),t=e(require("os")),r=e(require("glob")),o=require("cosmiconfig"),s=require("fs-extra"),i=e(s),l=e(require("path")),c=e(require("chalk")),a=e(require("simple-git/promise")),u=e(require("resolve"));require("core-js/modules/es.symbol.description");let f="";const d=(e,n=0)=>{const t=e instanceof Error?e:c.red.bold("ERROR: ")+e;f+=`${e}\n`,console.error(t),console.log("If you think this is a bug, you can report it: https://github.com/benawad/destiny/issues"),process.exit(n)};let p=!1,g=null;const h=(e,...n)=>{if(!p)return;const t=Date.now(),r=c.magenta.bold("DEBUG: ")+c.yellow.bold(`+${g?t-g:0}ms `)+e;f+=`${e}\n`,console.info(r),g=t,n.length>0&&(console.group(),n.forEach(e=>{console.dir(e,{depth:1/0,maxArrayLength:1/0}),console.log()}),console.groupEnd())};var m=d,b=e=>{const n=c.green.bold("INFO: ")+e;f+=`${e}\n`,console.info(n)},y=e=>{f+=`${e}\n`,console.log(e)},v=e=>{const n=c.yellow.bold("WARN: ")+e;f+=`${e}\n`,console.warn(n)},$=()=>{p=!0},j=h,x=e=>{if(!p)return;const t=l.resolve(e);n.existsSync(t)&&d(`The debug file output already exist "${t}".\nPlease give a path to a non existing file.`),n.writeFileSync(t,f,"utf8"),h(`stdout written in "${t}"`)};const w=e=>i.lstatSync(e).isDirectory(),S=e=>i.lstatSync(e).isFile(),F=e=>{const n=r.sync(e).map(e=>l.resolve(e)),t=n.filter(e=>S(e));return j(`glob matches for "${e}":`,n),0===t.length&&m("Could not find any files for: "+e,1),t},E=e=>{const n=[],t=[e];for(;t.length>0;){const e=t.shift();if(null==e||0===e.length)break;if(r.hasMagic(e))n.push(...F(e));else{if(!i.existsSync(e)){m(`Unable to resolve the path: ${e}`);break}w(e)?t.push(l.resolve(e,"./**/*.*")):S(e)&&n.push(e)}}return n};async function O(e,n){return e.silent(!0).raw(["ls-files","--error-unmatch",n]).then(()=>!0).catch(()=>!1)}async function k(e,n){const t=a(n),r=await t.checkIsRepo();for(const[o,s]of Object.entries(e)){if(o.includes(".."))continue;const e=l.resolve(n,o),c=l.resolve(n,s);if(e===c)continue;const a=l.dirname(c);i.ensureDirSync(a);const u=r&&await O(t,e);j(`moving "${e}" to "${c}"`),u?await t.mv(e,c):i.renameSync(e,c)}}function q(e){const t=n.readdirSync(e);if(!t)return n.rmdirSync(e);for(const r of t){const t=l.resolve(e,r);n.lstatSync(t).isDirectory()&&(q(t),0===n.readdirSync(t).length&&(n.rmdirSync(t),j(`removing "${t}" as empty folder`)))}}function R(e){const t="(?:(?:import|from)\\s+|(?:import|require)\\s*\\()\\\\?['\"`]((?:\\.{1,2})(?:\\/.+)?)\\\\?['\"`]",r=new RegExp(t,"gm"),o=new RegExp(`["'\`].*(${t}).*["'\`]`,"g"),s=new RegExp(`\`[^\`]*(${t})[^\`]*\``,"gm"),i=e=>" ".repeat(e.length),l=[],c=n.readFileSync(e,{encoding:"utf8"}).replace(/\/\*[\s\S]*?\*\/|\/\/.*/gm,i).replace(o,i).replace(s,i);let a;for(;null!==(a=r.exec(c));)l.push({path:a[1],start:r.lastIndex-1-a[1].length,end:r.lastIndex-1}),a.index===r.lastIndex&&r.lastIndex++;return l}const A=(e,n)=>{const t=l.dirname(e),r=l.relative(t,n),o=l.dirname(r),s=function(e){const n=l.extname(e);return[".js",".jsx",".ts",".tsx"].includes(n)?n:void 0}(r);let i=l.basename(r,s);"index"===i&&(i=".");let c=l.join(o,i);return!c.startsWith(".")&&(c="./"+c),"win32"===process.platform&&(c=c.replace(/\\/g,"/")),c},I=[".js",".json",".jsx",".sass",".scss",".svg",".ts",".d.ts",".tsx",".js.flow"],C=(e,n)=>{try{return u.sync(e,{basedir:n,extensions:I})}catch(e){return null}},D=(e,n)=>{for(const{tree:t,parentFolder:r}of n){const n=l.relative(r,e);if(n in t)return l.resolve(l.join(r,t[n]))}return e},M=(e,n,t)=>{for(const{tree:r,parentFolder:o}of t){const t=l.relative(o,e);if(t in r)return A(n,l.resolve(l.join(o,r[t])))}return A(n,e)},N=(e,n)=>{const t=n-e;return e>n?-Math.abs(t):t},P=async(e,n)=>{b("Fixing imports."),((e,n)=>{for(const t of e){j(`checking imports of "${t}"`);const e=R(t);if(0===e.length){j(`no import found in "${t}"`);continue}const r=l.dirname(t),o=D(t,n),i=s.readFileSync(t).toString();let c=i,a=0;for(const s of e){const e=C(s.path,r);if(null==e){m(`Cannot find import ${s.path} for ${r}`);continue}const i=M(e,o,n);null!=i&&s.path!==i&&(j(`replacing import of "${s.path}" by "${i}" in "${t}"`),c=`${c.substr(0,s.start+a)}${i}${c.substring(s.end+a)}`,a+=N(s.path.length,i.length))}c!==i&&(j(`writing new imports of "${t}"`),s.writeFileSync(t,c))}})(e,n);for(const{tree:e,parentFolder:t}of n)b("Moving files."),await k(e,t),q(t);b("Restructure was successful!")},G=e=>e.replace(/([^/]+)(?=\.)/g,String.fromCharCode(Number.MAX_SAFE_INTEGER)+"$1"),T=(e,n)=>G(e).localeCompare(G(n)),_=e=>{const n=e.reduce((e,n)=>{const t=n.split("/");return t.forEach((n,r)=>e.add(((e,n)=>l.join(...e.slice(0,n)))(t,r+1))),e},new Set);return Array.from(n).sort(T)},U=e=>{const n=(e=>{const n=[];let t=[...e];for(;t.length>0;){const e=t.shift();if(null==e)break;t=t.map(n=>{return t=e,n.replace(new RegExp(`^(/*)${t.replace(/\//g,"")}(/+)`),"$1$2");var t}),n.push(e)}return n.map(e=>{var n;const t=e.split("/");return{text:null!=(n=t.pop())?n:"",position:t.length}})})(_(e)),t=n.reduce((e,t,r)=>{var o;const s=null!=(o=e[r-1])?o:"",i=n.slice(r+1),l=i.length>0&&i[0].position>t.position,a=(t.position>0?"│  ".repeat(t.position):"")+(((e,n)=>{for(const t of n)if(!(t.position>e.position))return t.position<e.position;return!0})(t,i)?"└──":"├──")+(l?c.bold.blue(t.text):t.text);return e.push(((e,n)=>Array.from(e).map((e,t)=>"│"===e&&(e=>"└"===e||" "===e)(n[t])?" ":e).join(""))(a,s)),e},[]).join("\n");return y(t),t},W=e=>{if(1===e.length)return l.dirname(e[0]);const[n,t]=e.length>2?e.sort((e,n)=>e.length-n.length):e,r=t.split(l.sep);return n.split(l.sep).filter((e,n)=>e===r[n]).join(l.sep)},V=e=>[/^\.git/].some(n=>n.test(e));const z=e=>/\.test\.|\.spec\.|\.stories\./.test(e);function B(e){const n=(e=>{const n={};return Object.entries(e).forEach(([e,t])=>{t.forEach(t=>{t in n||(n[t]=[]),n[t].push(e)})}),n})(e),t=Object.keys(e),r=t.filter(e=>{const t=n[e];return!t||!t.length||t.every(e=>z(e))});if(r.length)return r;const o={};t.forEach(e=>{const n=e.split("/").length;n in o||(o[n]=[]),o[n].push(e)});for(let e=1;e<10;e++)if(e in o)return o[e];return[]}const L=(e,n,t)=>{const r=n[e];if(t.has(e))return[...t,e];if(t.add(e),null==r||0===r.length)return null;for(const e of r){const r=L(e,n,new Set(t));if(r)return r}return null};const X=e=>{const n=e.split(l.sep);if(1!==n.length)return n.pop(),n.join(l.sep)},H=e=>{const n=e.split(l.sep);return[...n.slice(0,n.length-2),n[n.length-1]].join(l.sep)};function J(e,{avoidSingleFile:n}){return Object.entries(e).reduce((e,[t,r])=>{if(r.length<=1)return e;b(`Generating tree for: ${t}`);const{graph:o,files:s,parentFolder:i}=function(e){const n=W(e),t={},r=[];for(let o of e){if(V(o))continue;o=l.resolve(o);const e=l.relative(n,o);r.push(e),R(o).forEach(r=>{const s=C(r.path,l.dirname(o));if(null==s)return void m(`Cannot find import ${r.path} for ${o}`);const i=l.relative(n,s);Array.isArray(t[e])||(t[e]=[]),t[e].includes(i)||t[e].push(i)})}return{files:r,graph:t,parentFolder:n}}(r);let a=function(e,n){const t={},r=new Set,o={},s=new Set;let i=!1;const c=(e,n)=>{Array.isArray(o[e])||(o[e]=[]),o[e].push(n)},a=(e,n,t)=>{if(r.has(e)){const e=l.join(n,t.replace(/\//g,"-"));return b(`File renamed: ${t} -> ${e}`),e}return e},u=(e,n)=>{t[e]=n,r.add(n)},f=(e,n,r)=>{const o=l.basename(e);if(z(o))return void s.add(e);let d=l.basename(e,l.extname(e));const p=l.basename(l.dirname(e)),g=e.includes(".."),h=g?e:l.join(n,"index"===d&&p&&"."!==p?p+l.extname(e):o),m=a(h,n,e);d=l.basename(m,l.extname(m)),g||u(e,m);const b=r[e];if((null==b?void 0:b.length)>0){const e=l.join(n,d);for(const n of b)if(n in t||n.includes("..")){const e=L(n,r,new Set);e?(i=!0,v(`Dependency cycle detected: ${e.join(" -> ")}`)):c(n,m)}else c(n,m),f(n,e,r)}};for(const t of n)f(t,"",e);if(i||Object.entries(o).forEach(([e,n])=>{if(n.length<=1||e.includes(".."))return;const t=W(n),r=l.basename(e),o=l.dirname(e),s=l.join(t,"shared","index"===l.basename(r,l.extname(r))&&o&&"."!==o?l.join(o+l.extname(r)):r);u(e,s)}),s.size>0)for(const n of s){const[r]=e[n];if(!r)continue;const o=t[r];if(!o)continue;const s=a(l.join(l.dirname(o),l.basename(n)),l.dirname(o),n);u(n,s)}return t}(o,B(o));n&&(a=(e=>{const n={...e},t={};for(const[e,r]of Object.entries(n))t[r]=e;const r={},o=Object.values(n).sort((e,n)=>n.length-e.length);for(const e of o){const n=X(e);n&&(r[n]=n in r?r[n]+1:1)}for(const e of o){const o=X(e);if(!o)continue;let s=r[o],i=e,l=o;for(;1===s&&(l=X(i),l);)o===l?s=1:l in r&&(s=r[l]+1),r[l]=s,1===s&&(i=H(i));n[t[e]]=i}return n})(a));const u=new Set(Object.entries(o).flat(2)),f=s.filter(e=>!u.has(e));return y(c.bold.blue(i.split(l.sep).pop())),U(Object.values(a)),f.length>0&&v(`Found ${f.length} unused files:`+"\n"+f.join("\n")),e.push({parentFolder:i,tree:a}),e},[])}const{argv:K}=process,Q={help:!1,include:[],version:!1,write:!1,avoidSingleFile:!1,debug:!1},Y=e=>e.replace(/~\/|~(?!.)/,`${t.homedir()}/`),Z=e=>((e=>{console.log(c`{blue destiny} - Prettier for file structures.

{bold USAGE}

${"  "}{blue destiny} [option...] [{underline path}]

${"  "}The {underline path} argument can consist of either a {bold file path} or a {bold glob}.

{bold OPTIONS}
`);const n=e.map(e=>({...e,flags:e.flags.join(", ")})),[t]=[...n].sort((e,n)=>n.flags.length-e.flags.length),r=`${t.flags}${"  ".repeat(2)}`.length,o=n.map(({flags:e,description:n})=>{const t=r-e.length;return`  ${e}${" ".repeat(t)}${n}`}).join("\n");console.log(o,"\n")})([{flags:["-V","--version"],description:"Output version number"},{flags:["-h","--help"],description:"Output usage information"},{flags:["-w","--write"],description:"Restructure and edit folders and files"},{flags:["-S","--avoid-single-file"],description:"Flag to indicate if single files in folders should be avoided"},{flags:["--debug [?output file]"],description:"Print debugging info"}]),process.exit(e)),ee=async e=>{const t=(e=>{var n,t;const r=null!=(n=null==(t=o.cosmiconfigSync("destiny").search())?void 0:t.config)?n:{};return{...Q,...r,...e}})((e=>{const t={};for(;e.length>0;){const s=e.shift();if(null==s)break;switch(s){case"-h":case"--help":t.help=!0;break;case"-V":case"--version":t.version=!0;break;case"-w":case"--write":t.write=!0;break;case"-S":case"--avoid-single-file":t.avoidSingleFile=!0;break;case"--debug":t.debug=!(e[0]&&!e[0].startsWith("-"))||e.shift();break;default:var o;if(n.existsSync(Y(s))||r.hasMagic(s))t.include=[...null!=(o=t.include)?o:[],s]}}return t})(e));if(t.help)return Z(0);if(t.version)return console.log("v0.7.0");if(0===t.include.length)return Z(1);t.debug&&$(),process.on("exit",()=>{"string"==typeof t.debug&&x(t.debug),j("exiting")}),j("version: 0.7.0"),j("config used:",t),t.include=t.include.map(Y);const s=t.include.reduce((e,n)=>({...e,[n]:E(n)}),{});const i=Object.values(s).flat();if(j("restructured map:",s),0===i.length)return void m("Could not find any files to restructure",1);const l=J(s,t);j("generated tree(s):",l),t.write&&await P(i,l)};ee(K.slice(2,K.length)),exports.run=ee;
